require 'spec_helper'

# Generators are not automatically loaded by Rails
require 'generators/cucumber/install/install_generator'

describe Cucumber::InstallGenerator do
  # Tell the generator where to put its output (what it thinks of as Rails.root)
  destination File.expand_path('../../../../../tmp', __FILE__)

  before { prepare_destination }

  describe 'no arguments' do
    before { run_generator  }

    describe 'config/cucumber.yml' do
      subject { file('config/cucumber.yml') }
      it { should exist }
      it { should contain 'default: <%= std_opts %> features' }
    end

    describe 'features/step_definitions folder' do
      subject { file('features/step_definitions') }
      it { should exist }
    end

    describe 'features/support/env.rb' do
      subject { file('features/support/env.rb') }
      it { should exist }
      it { should contain '# IMPORTANT: This file is generated by cucumber-rails - edit at your own peril.' }
      it { should contain "require 'cucumber/rails'" }
    end

    describe 'lib/tasks/cucumber.rake' do
      subject { file('lib/tasks/cucumber.rake') }
      it { should exist }
      it { should contain '# IMPORTANT: This file is generated by cucumber-rails - edit at your own peril.' }
      it { should contain "task :cucumber => 'cucumber:ok'" }
    end

    describe 'script/cucumber' do
      subject { file('script/cucumber') }
      it { should exist }
      it { should contain 'load Cucumber::BINARY' }
    end

  end
end
